#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>

#include "international.h"

/* interface */
extern gchar *path;

/* close with ESC or Return About Dialog */

static gint 
about_callback (GtkWidget *w, GdkEventKey *event, gpointer data)
{
	if ((event->keyval==0xFF1B) || (event->keyval==0xFF0D)) /* ESC - RETURN */
	gtk_widget_destroy (GTK_WIDGET(data));
	
	return 0;
}

/* About Window */

void
on_info_clicked (GtkButton * button, gpointer user_data)
{
  GtkWidget *window4;
  GtkWidget *notebook2;
  GtkWidget *textview1;
  GtkWidget *textview2;
  GtkWidget *label7;
  GtkWidget *scrolledwindow2;
  GtkWidget *scrolledwindow3;
  GtkWidget *label8;
  GtkWidget *vbox1;
  GtkWidget *hbuttonbox1;
  GtkWidget *button1;
  GdkPixbuf* pixbuf;
  GtkWidget *image;

  gchar readbuf[BUFSIZ];
  GtkTextBuffer *buffer;
  gchar **filter_argv;
  gchar *tmp_path;
  FILE *tmp;
	
  gint outputerr;


  window4 = gtk_window_new (GTK_WINDOW_TOPLEVEL /*POPUP*/);
  //gtk_widget_set_usize (window4, 400, 300);
  gtk_window_set_resizable (GTK_WINDOW(window4), FALSE);
  gtk_window_set_title (GTK_WINDOW (window4), _("About...") );
  gtk_window_set_position (GTK_WINDOW (window4), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (window4), TRUE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window4), vbox1);
  
  pixbuf = gdk_pixbuf_new_from_file(PACKAGE_DATA_DIR "/glsof/pixmaps/logo.png", NULL);
  image = gtk_image_new_from_pixbuf(pixbuf);
  //gtk_box_pack_end(GTK_BOX(vbox1), image, FALSE, FALSE, 0);
  gtk_container_add (GTK_CONTAINER (vbox1), image);
  g_object_unref(pixbuf);	
  gtk_widget_show(image);

  notebook2 = gtk_notebook_new ();
  gtk_widget_set_usize (notebook2, -1, 200);
  gtk_widget_show (notebook2);
  gtk_container_add (GTK_CONTAINER (vbox1), notebook2);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow2);
  gtk_container_add (GTK_CONTAINER (notebook2), scrolledwindow2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow2),
				       GTK_SHADOW_OUT);

  textview1 = gtk_text_view_new ();
  gtk_widget_show (textview1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), textview1);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (textview1), GTK_WRAP_WORD);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (textview1), FALSE);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (textview1), FALSE);
  gtk_text_buffer_set_text (gtk_text_view_get_buffer
			    (GTK_TEXT_VIEW (textview1)),
			    _("GLSOF v0.9.15 (old project name: GTK-Lsof)\n\nThis program is licensed GPL\nAuthor: Gnele aka blaad\nE-mail: blaadeleng@yahoo.com or\ngeekgnele@tin.it\n\nHome Page: http://glsof.sourceforge.net\n\nGLSOF is a GUI for LSOF.\nYou can Save output, Refresh (or Automatic Refresh) output, select fields of output and apply LSOF commands.\n\nFor Bugs, Infos and Others, please mail me. \n\nCredits:\nThanks to Vic Abell <abe@purdue.edu> for your work and help!\nThanks to syscalo <olacsys@myrealbox.com> for XML-Extension, suggestions, and courageous beta testing.\n\nbye\nGnele aka blaad\n(GNELE is Not ELEgant)\n"),
			    -1);

  label7 = gtk_label_new (_("GLSOF"));
  gtk_widget_show (label7);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (notebook2), 0),
			      label7);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);


  /* about lsof */
  
  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow3);
  gtk_container_add (GTK_CONTAINER (notebook2), scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow3),
				       GTK_SHADOW_OUT);

  textview2 = gtk_text_view_new ();
  gtk_widget_show (textview2);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), textview2);
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (textview2), GTK_WRAP_WORD);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (textview2), FALSE);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (textview2), FALSE);


  /* insert lsof -v */
  
  buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (textview2));
  
  tmp_path = g_strdup (path);
  g_strstrip (tmp_path);
  
  filter_argv = g_strsplit (tmp_path," ", -1);
  filter_argv[1] = "-v";
  
  g_spawn_async_with_pipes (
	NULL,
	filter_argv,
	NULL,
	0,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&outputerr,
	NULL );
		
  tmp = fdopen (outputerr, "r");
  
  while (fgets (readbuf, BUFSIZ, tmp))
    {
      gtk_text_buffer_insert_at_cursor (buffer, (gchar *) & readbuf[0], -1);
      memset (readbuf, 0, BUFSIZ);
	}
	
  g_free (tmp_path);
  g_strfreev(filter_argv);
	
  fclose (tmp);

/**********************/

  label8 = gtk_label_new (_("LSOF"));
  gtk_widget_show (label8);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (notebook2), 1),
			      label8);
  gtk_label_set_justify (GTK_LABEL (label8), GTK_JUSTIFY_LEFT);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox1), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1),
			     GTK_BUTTONBOX_DEFAULT_STYLE);

  button1 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (button1);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);
  
  gtk_widget_show (window4);
  gdk_window_raise (window4->window);
  
  /* signals */
  
  g_signal_connect (G_OBJECT (window4), "destroy",
                    G_CALLBACK (gtk_widget_destroy), NULL);
					
  g_signal_connect_swapped (G_OBJECT (button1), "clicked",
                    G_CALLBACK (gtk_object_destroy), (gpointer) window4);
			  
  g_signal_connect (G_OBJECT (window4), "key_press_event",
                    G_CALLBACK (about_callback), (gpointer) window4);
					
}
