#include <gtk/gtk.h>

#include "configuration.h"
#include "xmlconfig.h"
#include "international.h"


/* interface */
extern gchar *path;
extern GtkWidget *window1;		/* main window */

/* main */
extern gchar *path_config;

/* extern */
GtkWidget *sets_check_conf; /* save size/position window */
gboolean tmp_check_buts_conf;

GtkWidget *sets_check_show_splash_conf; /* splash window */
gboolean tmp_check_show_splash_conf;

GtkWidget *sets_entry_conf; /* path lsof */
gchar *tmp_entry_buts_conf;
/* _extern */

/* close with ESC or Return single My Dialog */

static gint 
conf_callback (GtkWidget *w, GdkEventKey *event, gpointer data)
{
	if (event->keyval==0xFF1B) /* ESC */
		gtk_widget_destroy (GTK_WIDGET (data));
	
	else if (event->keyval==0xFF0D) /* RETURN */
		on_configuration_ok (NULL,data);
	
	return 0;
}

/* Configuration Window */

void
on_configuration_clicked (GtkButton * button, gpointer user_data)
{

  GtkWidget *window5;
  GtkWidget *vbox4;
  GtkWidget *label1;
  GtkWidget *hbuttonbox4;
  GtkWidget *button21;
  GtkWidget *button22;
  GtkWidget *hseparator1;
  GtkWidget *table1;

  window5 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window5), _("Configuration"));
  gtk_window_set_position (GTK_WINDOW (window5), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (window5), TRUE);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (window5), vbox4);
  
  table1 = gtk_table_new (3, 2, TRUE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox4), table1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 8);

  label1 = gtk_label_new (_("Lsof Path: "));
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

  sets_check_conf =
    gtk_check_button_new_with_mnemonic (_("Keep Window Size/Position"));
  gtk_widget_show (sets_check_conf);
  gtk_table_attach (GTK_TABLE (table1), sets_check_conf, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check_conf),
				tmp_check_buts_conf);
				
  sets_check_show_splash_conf = gtk_check_button_new_with_mnemonic (_("Do not show Splash Window"));
  gtk_widget_show (sets_check_show_splash_conf);
  gtk_table_attach (GTK_TABLE (table1), sets_check_show_splash_conf, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check_show_splash_conf),
				tmp_check_show_splash_conf);

  sets_entry_conf = gtk_entry_new ();
  gtk_widget_show (sets_entry_conf);
  gtk_table_attach (GTK_TABLE (table1), sets_entry_conf, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_text (GTK_ENTRY (sets_entry_conf), tmp_entry_buts_conf);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_container_add (GTK_CONTAINER (vbox4), hseparator1);

/* buttons ok and cancel (this is the house - mickey mouse!) */

  hbuttonbox4 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox4);
  gtk_box_pack_start (GTK_BOX (vbox4), hbuttonbox4, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox4), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox4), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox4), 10);

  button21 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (button21);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), button21);
  GTK_WIDGET_SET_FLAGS (button21, GTK_CAN_DEFAULT);

  button22 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button22);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), button22);
  GTK_WIDGET_SET_FLAGS (button22, GTK_CAN_DEFAULT);
  
  gtk_widget_show (window5);
  gdk_window_raise (window5->window);
  
  /* signals */

  g_signal_connect (G_OBJECT (button21), "clicked",
		      G_CALLBACK (on_configuration_ok), (gpointer) window5);

  g_signal_connect_swapped (G_OBJECT (button22), "clicked",
		      G_CALLBACK (gtk_object_destroy), (gpointer) window5);

  g_signal_connect (G_OBJECT (window5), "destroy",
		      G_CALLBACK (gtk_object_destroy), NULL);
			  
  g_signal_connect (G_OBJECT (window5), "key_press_event",
              G_CALLBACK (conf_callback), (gpointer) window5);

  gtk_widget_grab_focus (window5);
  
}

/* other configuration signals */

void
on_configuration_ok (GtkButton * button, gpointer user_data)
{

  unsigned int ret, sp[4];
  gint x, y, w, h;
  int i = 0;

  tmp_check_buts_conf = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (sets_check_conf));
  tmp_check_show_splash_conf = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (sets_check_show_splash_conf));
  tmp_entry_buts_conf =	g_strdup (gtk_entry_get_text (GTK_ENTRY (sets_entry_conf)));

  ret = checkConfig (path_config);
  if (ERRCONF == ret)
    {
      puts ("ERROR");
      exit (1);
    }

  initWriteConfig (path_config);

  /* configuration */
  
  setLsofpath (tmp_entry_buts_conf);
  
  setKeepsizeposition (tmp_check_buts_conf);
  if (tmp_check_buts_conf)
    {
      gtk_window_get_position (GTK_WINDOW (window1), &x, &y);
      gtk_window_get_size (GTK_WINDOW (window1), &w, &h);
      sp[X] = (unsigned int) x;
      sp[Y] = (unsigned int) y;
      sp[WIDTH] = (unsigned int) w;
      sp[HEIGHT] = (unsigned int) h;

      setSizePosition (sp);
    }

  setSplashWindow(tmp_check_show_splash_conf);

  /* _configuration */

  destroyWriteConfig (path_config, 0);

  path = (char *) g_strjoin (NULL, tmp_entry_buts_conf, " -F ", NULL);
  while (path[i])
    {
      if (path[i] == '\n')
	path[i] = ' ';
      i++;
    }

  gtk_widget_destroy (GTK_WIDGET (user_data));

}
