#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

#include "settings.h"
#include "autorefresh.h"
#include "file_selection.h"
#include "international.h"


/* interface */
extern GtkListStore *command_info_table;	/* element for main table */

/* view_options */
extern gboolean state_fields[12];

/* main */
extern gchar *local_dir;

static GtkWidget *salva = NULL;

static gint tmp_val_sl;
static gchar *current_filename;
static gchar *filenameatrefresh;

FILE *file;

static char *format_fields[] = {
	"%-15s", "  %6s", "  %6s", "  %6s", "  %15s", "     %6s", " %4.4s", "  %10.10s", " %10.10s", " %6s ", " %10.10s", " %s" };

/* close with ESC or Return file_sel Dialog */

static gint 
filesel_callback (GtkWidget *w, GdkEventKey *event, gpointer data)
{
	if ((event->keyval==0xFF1B) && (GPOINTER_TO_INT(data)==4)) /* ESC */
		start_save_autorefresh (filenameatrefresh);
		
	
	if ((event->keyval==0xFF0D)) /* RETURN */
		on_ok_button1_clicked (NULL,(gpointer)tmp_val_sl);
	
	return 0;
}

/* File Selection Window */

static GtkWidget *
create_fileselection1 (gchar * title, gchar * button_name, gboolean hide,
		       gpointer * user_data)
{
  GtkWidget *fileselection1;
  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;
	
  filenameatrefresh = "";

  fileselection1 = gtk_file_selection_new (title);
  gtk_container_set_border_width (GTK_CONTAINER (fileselection1), 10);
  GTK_WINDOW (fileselection1)->type = GTK_WINDOW_TOPLEVEL;
  gtk_window_set_position (GTK_WINDOW (fileselection1), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (fileselection1), TRUE);

  if (hide)
    gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION
					    (fileselection1));

  /* ok_button1 = GTK_FILE_SELECTION (fileselection1)->ok_button; */

  gtk_widget_hide ((GTK_FILE_SELECTION (fileselection1)->ok_button));
  gtk_widget_hide ((GTK_FILE_SELECTION (fileselection1)->cancel_button));

  ok_button1 =
    gtk_dialog_add_button (GTK_DIALOG (fileselection1), button_name, 10);
  gtk_widget_show (ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

  cancel_button1 =
    gtk_dialog_add_button (GTK_DIALOG (fileselection1), _("Cancel"), 11);
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);
  
  /* signals */

  g_signal_connect (G_OBJECT (ok_button1), "clicked",
		      G_CALLBACK (on_ok_button1_clicked), user_data);
  
  g_signal_connect_swapped (G_OBJECT (cancel_button1), "clicked",
		      G_CALLBACK (gtk_object_destroy), (gpointer) fileselection1);
			  
  g_signal_connect (G_OBJECT (fileselection1), "key_press_event",
              G_CALLBACK (filesel_callback), GINT_TO_POINTER (user_data));

  return fileselection1;
}


/* Start Signals */

void
on_save_as_clicked (GtkButton * button, gpointer user_data)
{
  tmp_val_sl = GPOINTER_TO_INT (user_data);
	
  switch (GPOINTER_TO_INT (user_data)) {
	  
	  case 0:
		  salva = create_fileselection1 (_("Save Output As..."), _("Save"), FALSE, user_data);
	  	  break;
	  
	  case 1:
		  chdir ( local_dir );
		  salva = create_fileselection1 (_("Save Settings As..."), _("Save"), FALSE, user_data);
	      break;
	  
	  case 2:
		  chdir ( local_dir );
		  salva = create_fileselection1 (_("Load Settings From..."), _("Load"), TRUE, user_data);
	      break;
	  
	  case 3:
		  salva = create_fileselection1 (_("Save At Refresh..."), _("Save"), TRUE, user_data);
	      break;
	  
	  case 4:
		  salva = create_fileselection1 (_("Save AutoRefresh..."), _("Save"), TRUE, user_data);
	      break;
	  
  }
  
  if (current_filename)
    gtk_file_selection_set_filename (GTK_FILE_SELECTION (salva),
				     current_filename);
  gtk_widget_show (salva);
  gdk_window_raise (salva->window);

}

void
on_ok_button1_clicked (GtkButton * button, gpointer user_data)
{
  gchar *filename;
  time_t t;
  struct tm *tm_ptr;
  gchar date_buffer[16];

  switch (GPOINTER_TO_INT (user_data)) {
	  
	  case 0:
		  /* filesel = gtk_widget_get_toplevel (GTK_WIDGET (button)); */
          filename = (gchar *) gtk_file_selection_get_filename (GTK_FILE_SELECTION (salva));/* filesel)); */
		  gtk_widget_destroy (salva);
	      salva=NULL;
	      save_output (filename);
	  	  break;
	  
	  case 1:
		  /* filesel = gtk_widget_get_toplevel (GTK_WIDGET (button)); */
	      filename = (gchar *) gtk_file_selection_get_filename (GTK_FILE_SELECTION (salva));/* filesel)); */
	      gtk_widget_destroy (salva);
	      salva=NULL;
	      save_sets (filename);
	      break;
	  
	  case 2:
		  filename = (gchar *) gtk_file_selection_get_filename (GTK_FILE_SELECTION (salva));/* filesel)); */
	      gtk_widget_destroy (salva);
	      salva=NULL;
	      load_sets (filename);
	      break;
	  
	  case 3:
		  /* filesel = gtk_widget_get_toplevel (GTK_WIDGET (button)); */
		  if (salva)
			  {
				  filenameatrefresh = (gchar *) gtk_file_selection_get_filename (GTK_FILE_SELECTION (salva));/* filesel)); */
				  gtk_widget_destroy (salva);
				  salva=NULL;
			  }
			  
		  time (&t);
		  tm_ptr = localtime (&t);
		  strftime (date_buffer, 16, "%Y%m%d%k%M%S", tm_ptr);
		
		  save_output(g_strconcat (filenameatrefresh,&date_buffer[0],NULL));
		  break;
			  
	   case 4:
		   if (salva)
			   {
				   filenameatrefresh = (gchar *) gtk_file_selection_get_filename (GTK_FILE_SELECTION (salva));
				   gtk_widget_destroy (salva);
				   salva=NULL;
			   }
			
		   start_save_autorefresh (filenameatrefresh);
		   break;
			   
		   }		/* _switch */

}

/* start read and copy of infos in main table */

gboolean
  foreach_func (GtkTreeModel *model,
                GtkTreePath  *path,
                GtkTreeIter  *iter,
                gpointer      user_data)
  {
    gchar *text[12];
	int i;

	/* get single row */
	  
    gtk_tree_model_get (model, iter,
                        0, &text[0], 1, &text[1], 2, &text[2], 3, &text[3],
	  					4, &text[4], 5, &text[5], 6, &text[6], 7, &text[7],
	  					8, &text[8], 9, &text[9], 10, &text[10], 11, &text[11],
	  					-1);

	for (i = 0; i < 12; i++)
	{
	      if (state_fields[i])
			  fprintf (file, format_fields[i], text [i]);
		  
		  g_free (text[i]);
	}
	
	fprintf (file, "\n");

    return FALSE; /* do not stop walking the store, call us with next row */
  }


void
save_output (gchar * filename)
{
	int i;
	
	static gchar *n_f[] = { "COMMAND", "PID", "PGID", "PPID", "USER", "FD", "TYPE", "DEVICE", "SIZE/OFF", "NLINK", "INODE", "NAME" };

    file = fopen ((const gchar *) filename, "w");
		  
    if (file == NULL)
		return;

    for (i = 0; i < 12; i++)
		if (state_fields[i])
			fprintf (file, format_fields[i], n_f[i]);
	
    fprintf (file, "\n");
	
	gtk_tree_model_foreach(GTK_TREE_MODEL(command_info_table), foreach_func, NULL);
		
	fclose (file);
	return;
}
