#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "view_options.h"
#include "file_selection.h"
#include "interface.h"
#include "settings.h"
#include "configuration.h"
#include "autorefresh.h"
#include "about.h"
#include "xmlconfig.h"
#include "refresh.h"
#include "international.h"


/* configuration */
extern gboolean tmp_check_buts_conf;

/* list_int_addr */
extern GPtrArray *tmp_add_list;

/* main */
extern gchar *path_config;

/* extern */
GtkWidget *view;	/* element for main table */
GtkListStore *command_info_table;	/* element for main table */
GtkWidget *scrolledwindow1;
GtkWidget *scrolledwindow_sets;
GtkWidget *scrolledwindow3;

GtkWidget *window1;		/* main window */
GtkWidget *entry[24];

gchar *path;

char *name_fields[12];
int width[12];

char *opt_commands[20];
char *opt_commands2[20];

gchar *commands_lsof;
GtkWidget *save_view_options_too1;
GtkWidget *save_at_refresh1;
GtkWidget *save_as2;
gboolean first_save_at_refresh_call;
/* end extern */

char *name_fields[] = {
  "COMMAND       ", "PID    ", "PGID    ", "PPID  ", "USER      ", "FD   ",
    "TYPE      ", "DEVICE    ", "SIZE     ", "NLINK   ", "NODE  ", "NAME"
};


char *opt_commands[] =
  { " -a ", " -b ", " -C ", " -l ", " -n ", " -N ", " +M ", " -M ", " -O ",
" -P ",
  " -R ", " -s ", " -t ", " -U ", " -V ", " +w ", " -w ", " -X ", " -- ",
    "CLEAR"
};


char *opt_commands2[] =
  { " -A ", " -c ", " +d ", " -d ", " +D ", " -D ", " +f ", " -f ", " -F ",
" -g ", " -i ", " -k ", " +L ",
  " -L ", " -m ", " -o ", " -p ", " -S ", " -T ", " -u "
};

/* signal interface */
void
on_refresh_clicked (GtkButton * button, gpointer user_data)
{
  gtk_list_store_clear (command_info_table);
  update_clist ();
}

static void
wrap_load_sets (GtkButton * button, gpointer user_data)
{
  load_sets(path_config);
}

static void
wrap_save_sets (GtkButton * button, gpointer user_data)
{
  save_sets(path_config);
}

static void
on_window1_destroy (GtkObject * object, gpointer user_data)
{
  g_ptr_array_free (tmp_add_list,FALSE);
	
  if (tmp_check_buts_conf)
    on_configuration_ok (NULL, NULL);
  
  gtk_main_quit ();
}

/* Main Window */

GtkWidget *
create_window1 (void)
{
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *menuitem1;
  GtkWidget *menuitem1_menu;
  GtkWidget *load_settings1;
  GtkWidget *load_settings_from1;
  GtkWidget *separatore1;
  GtkWidget *save_settings1;
  GtkWidget *save_settings_as1;
  GtkWidget *separatormenuitem1;
  GtkWidget *quit2;
  GtkWidget *menuitem2;
  GtkWidget *menuitem2_menu;
  GtkWidget *view_options1;
  GtkWidget *settings1;
  GtkWidget *configuration1;
  GtkWidget *menuitem3;
  GtkWidget *menuitem3_menu;
  GtkWidget *refresh1;
  GtkWidget *autorefresh1;
  GtkWidget *separatore3;
  GtkWidget *menuitem4;
  GtkWidget *menuitem4_menu;
  GtkWidget *about1;
  GtkAccelGroup *accel_group;
  
  GtkTreeSelection *selection;	/* element for main table */
  GtkCellRenderer *cell;	/* element for main table */
  GtkTreeViewColumn *column; /* element for main table */

  int i = 0;

  accel_group = gtk_accel_group_new ();

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window1), (_("GLSOF (Big Brother)") ));
  gtk_window_resize (GTK_WINDOW (window1), 700, 525);
  gtk_widget_realize (window1);
  gtk_window_add_accel_group (GTK_WINDOW (window1), accel_group);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);

  menuitem1 = gtk_menu_item_new_with_mnemonic (_("_File"));
  gtk_widget_show (menuitem1);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem1);

  menuitem1_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem1), menuitem1_menu);

  load_settings1 = gtk_menu_item_new_with_mnemonic (_("_Load Settings"));
  gtk_widget_show (load_settings1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), load_settings1);
  gtk_widget_add_accelerator (load_settings1, "activate", accel_group,
			      GDK_L, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  load_settings_from1 =
    gtk_menu_item_new_with_mnemonic (_("Load Settings From..."));
  gtk_widget_show (load_settings_from1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), load_settings_from1);

  separatore1 = gtk_menu_item_new ();
  gtk_widget_show (separatore1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), separatore1);
  gtk_widget_set_sensitive (separatore1, FALSE);

  save_settings1 = gtk_menu_item_new_with_mnemonic (_("_Save Settings"));
  gtk_widget_show (save_settings1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), save_settings1);
  gtk_widget_add_accelerator (save_settings1, "activate", accel_group,
			      GDK_S, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  save_settings_as1 =
    gtk_menu_item_new_with_mnemonic (_("Save Settings As..."));
  gtk_widget_show (save_settings_as1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), save_settings_as1);

  save_view_options_too1 =
    gtk_check_menu_item_new_with_mnemonic (_("Save View Options too"));
  gtk_widget_show (save_view_options_too1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), save_view_options_too1);

  separatormenuitem1 = gtk_menu_item_new ();
  gtk_widget_show (separatormenuitem1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), separatormenuitem1);
  gtk_widget_set_sensitive (separatormenuitem1, FALSE);

  quit2 = gtk_menu_item_new_with_mnemonic (_("_Quit"));
  gtk_widget_show (quit2);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), quit2);
  gtk_widget_add_accelerator (quit2, "activate", accel_group,
			      GDK_Q, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  menuitem2 = gtk_menu_item_new_with_mnemonic (_("_Edit"));
  gtk_widget_show (menuitem2);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem2);

  menuitem2_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem2), menuitem2_menu);

  view_options1 = gtk_menu_item_new_with_mnemonic (_("View Options"));
  gtk_widget_show (view_options1);
  gtk_container_add (GTK_CONTAINER (menuitem2_menu), view_options1);
  gtk_widget_add_accelerator (view_options1, "activate", accel_group,
			      GDK_V, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  settings1 = gtk_menu_item_new_with_mnemonic (_("Settings"));
  gtk_widget_show (settings1);
  gtk_container_add (GTK_CONTAINER (menuitem2_menu), settings1);
  gtk_widget_add_accelerator (settings1, "activate", accel_group,
			      GDK_E, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  configuration1 = gtk_menu_item_new_with_mnemonic (_("Configuration"));
  gtk_widget_show (configuration1);
  gtk_container_add (GTK_CONTAINER (menuitem2_menu), configuration1);
  gtk_widget_add_accelerator (configuration1, "activate", accel_group,
			      GDK_C, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  menuitem3 = gtk_menu_item_new_with_mnemonic (_("_Output"));
  gtk_widget_show (menuitem3);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem3);

  menuitem3_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem3), menuitem3_menu);

  refresh1 = gtk_menu_item_new_with_mnemonic (_("Refresh"));
  gtk_widget_show (refresh1);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), refresh1);
  gtk_widget_add_accelerator (refresh1, "activate", accel_group,
			      GDK_R, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
				  
  autorefresh1 = gtk_menu_item_new_with_mnemonic (_("Auto Refresh"));
  gtk_widget_show (autorefresh1);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), autorefresh1);
  gtk_widget_add_accelerator (autorefresh1, "activate", accel_group,
			      GDK_A, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  separatore3 = gtk_menu_item_new ();
  gtk_widget_show (separatore3);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), separatore3);
  gtk_widget_set_sensitive (separatore3, FALSE);

  save_as2 = gtk_menu_item_new_with_mnemonic (_("Save As..."));
  gtk_widget_show (save_as2);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), save_as2);
  gtk_widget_add_accelerator (save_as2, "activate", accel_group,
			      GDK_O, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

  save_at_refresh1 =
    gtk_check_menu_item_new_with_mnemonic (_("Save At Refresh..."));
  gtk_widget_show (save_at_refresh1);
  gtk_container_add (GTK_CONTAINER (menuitem3_menu), save_at_refresh1);

  menuitem4 = gtk_menu_item_new_with_mnemonic (_("_Help"));
  gtk_widget_show (menuitem4);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem4);
  gtk_menu_item_set_right_justified (GTK_MENU_ITEM (menuitem4), TRUE);

  menuitem4_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem4), menuitem4_menu);

  about1 = gtk_menu_item_new_with_mnemonic (_("_About"));
  gtk_widget_show (about1);
  gtk_container_add (GTK_CONTAINER (menuitem4_menu), about1);


  /* scrolled window for main list */
  
  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_container_add (GTK_CONTAINER (vbox1), scrolledwindow1);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow1),
				       GTK_SHADOW_OUT);
					   
  /* make main column-list */
  
  view = gtk_tree_view_new ();
  selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (view));

  gtk_tree_selection_set_mode (selection, GTK_SELECTION_SINGLE);
  command_info_table = gtk_list_store_new (12, \
  										   G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, \
  										   G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);

  gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (view), TRUE);	/* white - grey alternate */
  
  gtk_tree_view_set_model (GTK_TREE_VIEW (view),
				 GTK_TREE_MODEL (command_info_table));

  
  for (i = 0; i < 12; i++)
    {
		cell = gtk_cell_renderer_text_new ();
		column = gtk_tree_view_column_new_with_attributes(name_fields[i], cell, "text", i, NULL);
		gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);
		
		if ( (i==0) || (i==11) )
			gtk_tree_view_column_set_sort_column_id(column, i);
		
		gtk_tree_view_append_column(GTK_TREE_VIEW(view), column);
	}
	
  gtk_widget_show (view);
	
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), view);
	
  /* make array of pointers for 'list addresses' interface */

  tmp_add_list = g_ptr_array_new ();
	
  /* define signals for main interface */

  g_signal_connect ((gpointer) load_settings1, "activate",
		    G_CALLBACK (wrap_load_sets), NULL);
  g_signal_connect ((gpointer) load_settings_from1, "activate",
		    G_CALLBACK (on_save_as_clicked), GINT_TO_POINTER (2));
  g_signal_connect ((gpointer) save_settings1, "activate",
		    G_CALLBACK (wrap_save_sets), NULL);
  g_signal_connect ((gpointer) save_settings_as1, "activate",
		    G_CALLBACK (on_save_as_clicked), GINT_TO_POINTER (1));
  
  g_signal_connect ((gpointer) quit2, "activate",
		    G_CALLBACK (on_window1_destroy), NULL);
  g_signal_connect ((gpointer) view_options1, "activate",
		    G_CALLBACK (on_preferences_clicked), NULL);
  g_signal_connect ((gpointer) settings1, "activate",
		    G_CALLBACK (on_settings_clicked), NULL);
  g_signal_connect ((gpointer) configuration1, "activate",
		    G_CALLBACK (on_configuration_clicked), NULL);
  g_signal_connect ((gpointer) refresh1, "activate",
		    G_CALLBACK (on_refresh_clicked), NULL);
  g_signal_connect ((gpointer) autorefresh1, "activate",
		    G_CALLBACK (on_autorefresh_clicked), NULL);
  g_signal_connect ((gpointer) save_as2, "activate",
		    G_CALLBACK (on_save_as_clicked), GINT_TO_POINTER (0));
  g_signal_connect ((gpointer) about1, "activate",
		    G_CALLBACK (on_info_clicked), NULL);
			
  g_signal_connect ((gpointer) window1, "delete-event",
		    G_CALLBACK (on_window1_destroy), NULL);			

  /* load default preferences and launch first automatic refresh*/
  
  load_sets (path_config);
  on_refresh_clicked (NULL,NULL);

  return window1;
}
