#include <gtk/gtk.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>

#include "interface.h"
#include "xmlconfig.h"
#include "configuration.h"
#include "international.h"

#define ERROR_DIALOG(msg) GtkWidget *dialog; \
						  dialog = gtk_message_dialog_new (GTK_WINDOW (window1), \
						  GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, msg); \
						  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER); \
						  gtk_dialog_run (GTK_DIALOG (dialog)); \
						  gtk_widget_destroy (dialog); \
						  exit (1);

/* configuration */
extern gchar *tmp_entry_buts_conf;

/* interface */
extern gchar *path;
extern GtkWidget *window1;		/* main window */

/* extern */
gchar *path_config;
gchar *local_dir;


static
gboolean Write_Config(void)
{
	FILE *fc;

	fc = fopen (path_config, "w");
	if (fc == NULL)
		return TRUE;
	
fprintf (fc, "%s", "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n");
fprintf (fc, "%s", "<configuration>\n");
fprintf (fc, "%s", "	<viewoptions>\n");
fprintf (fc, "%s", "		<pid selected=\"1\"/>\n");
fprintf (fc, "%s", "		<pgid selected=\"1\"/>\n");
fprintf (fc, "%s", "		<ppid selected=\"1\"/>\n");
fprintf (fc, "%s", "		<user selected=\"1\"/>\n");
fprintf (fc, "%s", "		<fd selected=\"1\"/>\n");
fprintf (fc, "%s", "		<type selected=\"1\"/>\n");
fprintf (fc, "%s", "		<device selected=\"1\"/>\n");
fprintf (fc, "%s", "		<sizeoffset selected=\"1\"/>\n");
fprintf (fc, "%s", "		<nlink selected=\"1\"/>\n");
fprintf (fc, "%s", "		<node selected=\"1\"/>\n");
fprintf (fc, "%s", "	</viewoptions>\n");
fprintf (fc, "%s", "	<lsofsettings>\n");
fprintf (fc, "%s", "		<general>\n");
fprintf (fc, "%s", "			<andsettings selected=\"0\"/>\n");
fprintf (fc, "%s", "			<idorlogin>id</idorlogin>\n");
fprintf (fc, "%s", "			<offsetorsize>size</offsetorsize>\n");
fprintf (fc, "%s", "			<hidefromoutput selected=\"1\"/>\n");
fprintf (fc, "%s", "		</general>\n");
fprintf (fc, "%s", "		<files>\n");
fprintf (fc, "%s", "			<processesexecuting selected=\"0\"></processesexecuting>\n");
fprintf (fc, "%s", "			<idprocesses selected=\"0\"></idprocesses>\n");
fprintf (fc, "%s", "			<pgidprocesses selected=\"0\"></pgidprocesses>\n");
fprintf (fc, "%s", "		</files>\n");
fprintf (fc, "%s", "		<processes>\n");
fprintf (fc, "%s", "			<displaydirectory selected=\"0\" completedepth=\"1\"></displaydirectory>\n");
fprintf (fc, "%s", "			<filedescriptors selected=\"0\" action=\"exclude\"></filedescriptors>\n");
fprintf (fc, "%s", "			<nameandid selected=\"0\"></nameandid>\n");
fprintf (fc, "%s", "			<maxlinks selected=\"0\"></maxlinks>\n");
fprintf (fc, "%s", "		</processes>\n");
fprintf (fc, "%s", "		<network>\n");
fprintf (fc, "%s", "			<internetaddresses selected=\"0\"/>\n");
fprintf (fc, "%s", "			<ipaddress selected=\"0\"/>\n");
fprintf (fc, "%s", "			<portnumber selected=\"0\"/>\n");
fprintf (fc, "%s", "			<nfsfiles selected=\"0\"/>\n");
fprintf (fc, "%s", "			<unixsocket selected=\"0\"/>\n");
fprintf (fc, "%s", "		</network>\n");
fprintf (fc, "%s", "		<kernel>\n");
fprintf (fc, "%s", "			<timeout selected=\"0\">1</timeout>\n");
fprintf (fc, "%s", "			<avoiddangerous selected=\"0\"/>\n");
fprintf (fc, "%s", "		</kernel>\n");
fprintf (fc, "%s", "        </lsofsettings>\n");
fprintf (fc, "%s", "\n");
fprintf (fc, "%s", "	<config>\n");
fprintf (fc, "%s", "		<lsofpath></lsofpath>\n");
fprintf (fc, "%s", "		<keepsizeposition selected=\"0\">\n");
fprintf (fc, "%s", "			<x>165</x>\n");
fprintf (fc, "%s", "			<y>113</y>\n");
fprintf (fc, "%s", "			<width>700</width>\n");
fprintf (fc, "%s", "			<height>525</height>\n");
fprintf (fc, "%s", "		</keepsizeposition>\n");
fprintf (fc, "%s", "		<hidesplashwindow selected=\"0\"/>\n");
fprintf (fc, "%s", "	</config>\n");
fprintf (fc, "%s", "</configuration>\n");

fclose (fc);

return FALSE;

}

static
gboolean Read_Config(void)
{
  int ret;
  struct stat buf;
  gboolean show_error = TRUE;
  
	ret = checkConfig (path_config);
  if (ERRCONF == ret)
    exit(1);

  initWriteConfig (path_config);

  getLsofpath ((xmlChar **) & path);
  destroyReadConfig ();

  stat (path, &buf);
  if (access (path, X_OK | F_OK) || (buf.st_mode & S_IFDIR))
    {
      FILE *fp;
      gchar readbuf[BUFSIZ];
      gchar **tmp = NULL;
      int i = 0, s = 0;

      if ((fp = popen ("whereis -b lsof", "r")))
	{

	  if (fgets (readbuf, BUFSIZ, fp))
	    tmp = g_strsplit (readbuf, " ", -1);
	  
	  pclose (fp);

	  while (readbuf[i])
	    {
	      if (readbuf[i] == ' ')
		s++;
	      i++;
	    }

	  if (s)
	    {
	      int k = 1;

	      while (k <= s)
		{
		  i = 0;
			
		  while (tmp[k][i] != 0)
		    {
		      if (tmp[k][i] == '\n')
			tmp[k][i] = 0;
		      i++;
		    }

		  stat (tmp[k], &buf);
		  if (!access (tmp[k], X_OK | F_OK) && !(buf.st_mode & S_IFDIR))
		    {
		      ret = checkConfig (path_config);
		      if (ERRCONF == ret || -1 == ret)
			exit(1);

		      ret = initWriteConfig (path_config);
		      if (-1 == ret)
			exit (1);
			  
			  setLsofpath((xmlChar *)tmp[k]);
			  
			  ret = destroyWriteConfig (path_config, 0);
  			  if (-1 == ret) 
				  exit(1);

		      tmp_entry_buts_conf = g_strdup (tmp[k]);
		      path = (char *) g_strconcat (tmp[k], " -F", NULL);
			  
			  show_error = FALSE;
			  
			  break;
		    }
			
			k++;

		 }

	    }
	  else 
		  tmp_entry_buts_conf = "";
	  
	}

      g_strfreev (tmp);
    }
  else
    {
      tmp_entry_buts_conf = g_strdup (path);
      path = (char *) g_strconcat (path, " -F ", NULL);
	  show_error = FALSE;
    }
	
	return show_error;
}


int
main (int argc, char *argv[])
{
  gboolean show_error_read_config = TRUE;
  gboolean show_error_write_config = FALSE;
  
#ifdef ENABLE_NLS
    bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
    bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
    textdomain (GETTEXT_PACKAGE);
#endif
	
  /* mkdir $HOME/.glsof and control if config.xml
	 exists in this directory. If it exists read
	 config for this file else make it */

  local_dir = g_strconcat(g_get_home_dir(), "/.glsof", NULL);
  mkdir(local_dir, S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
  path_config = g_strconcat(local_dir, "/config.xml", NULL);
	
  if (!g_file_test (path_config, G_FILE_TEST_EXISTS))
	  show_error_write_config = Write_Config();
  
  show_error_read_config = Read_Config();
  
  gtk_set_locale ();
  gtk_init (&argc, &argv);

  window1 = create_window1 ();
	
  if (show_error_read_config) 
	  {
		  ERROR_DIALOG (_("Fatal error: lsof not found.\nMaybe problems with \"$HOME/.glsof/config.xml\" file.\nPlease Control."));
	  }
	  
  if (show_error_write_config) 
	  {
		  ERROR_DIALOG (_("Fatal error: I can't create \"$HOME/.glsof/config.xml\" file.\nPlease, control permissions."));
	  }
	  
  gtk_widget_show (window1);
  gtk_main ();
  return 0;
}
