#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <time.h>

#include "file_selection.h"
#include "list_int_addr.h"
#include "about.h"
#include "international.h"

#define ADD_ROW		gtk_list_store_append (GTK_LIST_STORE(command_info_table), &iter);

#define FILL_ROW	gtk_list_store_set (command_info_table, &iter, \
							0, tcp[0], 1, tcp[1], 2, tcp[2], 3, tcp[3], \
							4, tcp[4], 5, tcp[5], 6, tcp[6], 7, tcp[7], \
							8, tcp[8], 9, tcp[9], 10, tcp[10], 11, tcp[11], \
							-1);

/* autorefresh */
extern guint timeout_id;

/* interface */
extern GtkWidget *save_at_refresh1;
extern GtkListStore *command_info_table;
extern gchar *commands_lsof;
extern gchar *path;
extern int width[12];
extern gboolean first_save_at_refresh_call;
extern gchar *commands_lsof;

/* settings */
extern gboolean tmp_radio_buts[6];
extern gboolean tmp_check_buts[17];
extern gchar *tmp_entry_buts[7];

/* list_int_addr */
extern GPtrArray *tmp_add_list;

/* configuration */
extern gboolean tmp_check_show_splash_conf;

/* local */
static guint timeout_splash_window = 0;
static GtkWidget *splash_window = NULL;
static gint append_num;

static void
control_settings (void)
{

  commands_lsof = " ";

/* page 0 */

/* -l */
  if (tmp_radio_buts[0])
    commands_lsof = g_strconcat (commands_lsof, " -l ", NULL);

/* -o -s */
  if (tmp_radio_buts[1])
    commands_lsof = g_strconcat (commands_lsof, " -o ", NULL);
  else
    commands_lsof = g_strconcat (commands_lsof, " -s ", NULL);

/* -a */
  if (tmp_check_buts[0])
    commands_lsof = g_strconcat (commands_lsof, " -a ", NULL);

/* page 1 */

/* -c */
  if (tmp_check_buts[1])
    commands_lsof = g_strconcat (commands_lsof, " -c ", 
  								g_strjoinv (" -c ", g_strsplit (tmp_entry_buts[0], ",", -1)), 
  								NULL);

/* -p */
  if (tmp_check_buts[2])
    commands_lsof =
      g_strconcat (commands_lsof, " -p ", tmp_entry_buts[1], NULL);

/* -g */
  if (tmp_check_buts[3])
    commands_lsof =
      g_strconcat (commands_lsof, " -g ", tmp_entry_buts[2], NULL);

/* page 2 */

/* +d +D */
  if (tmp_check_buts[4])
    {
      if (tmp_check_buts[8])
	commands_lsof =
	  g_strconcat (commands_lsof, " +D ", tmp_entry_buts[3], NULL);
      else
	commands_lsof =
	  g_strconcat (commands_lsof, " +d ", tmp_entry_buts[3], NULL);
    }

/* -d */
  if (tmp_check_buts[5])
    {
      if (tmp_radio_buts[4])
	commands_lsof =
	  g_strconcat (commands_lsof, " -d ", tmp_entry_buts[4], NULL);
      else
	commands_lsof = g_strconcat (commands_lsof, " -d ^", 
	  							g_strjoinv (",^", g_strsplit (tmp_entry_buts[4], ",", -1)),
	  							NULL);
    }

/* -u */
  if (tmp_check_buts[6])
    commands_lsof =
      g_strconcat (commands_lsof, " -u ", tmp_entry_buts[5], NULL);

/* +L */
  if (tmp_check_buts[7])
    commands_lsof =
      g_strconcat (commands_lsof, " +L ", tmp_entry_buts[6], NULL);

/* page 3 */

/* -i */
  if (tmp_check_buts[9])
  {
	  int i=0;
	  node_data *elem;
	  
	  if (tmp_add_list->len == 0)
		  commands_lsof = g_strconcat (commands_lsof, " -i ", NULL);
	  
	  else 		  
		  while (i < tmp_add_list->len)
		  {
			  elem = g_ptr_array_index(tmp_add_list, i);
			  commands_lsof = g_strconcat (commands_lsof, " -i ", elem->option, NULL);
			  i++;
		  }
  }

/* -n */
  if (tmp_check_buts[10])
    commands_lsof = g_strconcat (commands_lsof, " -n ", NULL);

/* -N */
  if (tmp_check_buts[11])
    commands_lsof = g_strconcat (commands_lsof, " -N ", NULL);

/* -P */
  if (tmp_check_buts[12])
    commands_lsof = g_strconcat (commands_lsof, " -P ", NULL);

/* -U */
  if (tmp_check_buts[13])
    commands_lsof = g_strconcat (commands_lsof, " -U ", NULL);

/* page 4 */

/* -S */
  if (tmp_check_buts[14])
    commands_lsof =
      g_strconcat (commands_lsof, " -S ", tmp_entry_buts[7], NULL);

/* -b */
  if (tmp_check_buts[15])
    commands_lsof = g_strconcat (commands_lsof, " -b ", NULL);

  /* printf ("########### %s\n", commands_lsof); */
}


static
void make_splash_window(void)
{
	GtkWidget *vbox;
	GdkPixbuf* pixbuf;
	GtkWidget *image;
	GtkWidget *label;
	
	splash_window = gtk_window_new (GTK_WINDOW_POPUP);
	gtk_window_set_position (GTK_WINDOW (splash_window), GTK_WIN_POS_CENTER);
    gtk_window_set_decorated(GTK_WINDOW(splash_window), FALSE);
    gtk_window_set_resizable(GTK_WINDOW(splash_window),FALSE);
    //gtk_widget_set_usize(splash_window, 324,29);

	vbox = gtk_vbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(splash_window), vbox);
	gtk_widget_show(vbox);

	gtk_widget_realize(splash_window);
	gdk_window_set_decorations(splash_window->window, 0);
	
	label = gtk_label_new(_("please wait, glsof at work..."));
    gtk_box_pack_end(GTK_BOX(vbox),label , FALSE, FALSE, 0);
    gtk_widget_show(label);
	
	pixbuf = gdk_pixbuf_new_from_file(PACKAGE_DATA_DIR "/glsof/pixmaps/logo.png", NULL);
	image = gtk_image_new_from_pixbuf(pixbuf);
	gtk_box_pack_end(GTK_BOX(vbox), image, FALSE, FALSE, 0);
	g_object_unref(pixbuf);	
	gtk_widget_show(image);
		
	gtk_widget_show(splash_window);
	
	while(g_main_context_pending(NULL) || !GTK_WIDGET_REALIZED(image))
		gtk_main_iteration();
}

static gboolean
close_splash_window (gpointer data)
{
	gtk_timeout_remove (timeout_splash_window);
	gtk_widget_destroy(splash_window);
	splash_window = NULL;
		
	return TRUE;
}


void
update_clist (void)
{
  gchar readbuf[BUFSIZ];
  gchar readbuf2[12][BUFSIZ];
  gchar readbuf3[12][BUFSIZ];
  gchar *lsof_info[12];
  gchar *tmp2;
  gchar **filter_argv;
	
  gchar fd[10];
  gchar *tcp[12];
	
  gint mod = 1000;

  gboolean print = FALSE;
  gboolean repeat = FALSE;
	
  GtkTreeIter iter;

  gint i,j;
  gint output=0;
  FILE *fp;
  
  /* show splash window */
  
  if (tmp_check_show_splash_conf == FALSE)
  {
	  if (splash_window != NULL)
		  gtk_timeout_remove (timeout_splash_window);
	  else
		  make_splash_window();
  }
  
  /* start settings for control */
  
  append_num = 0;

  commands_lsof = NULL;
  
  control_settings ();
  
  tmp2 = malloc (strlen(commands_lsof));

  if (commands_lsof)
  {
	g_strstrip(commands_lsof);
	  
	i=1;
	j=1;
	tmp2 [0] = commands_lsof[0];
	  
	  while (commands_lsof[i])
	  {
		  if (!((commands_lsof[i]==' ') && (commands_lsof[i-1]==' ')))
		  tmp2 [j++] = commands_lsof[i];
		  i++;
	  }
	  
	  tmp2 [j] = 0;
      commands_lsof = g_strconcat (path, tmp2, NULL);
  }
  else
    commands_lsof = g_strdup (path);
  
  printf ("########### %s\n", commands_lsof);
  
  filter_argv = g_strsplit (commands_lsof," ", -1);
  
  g_free (commands_lsof);
  g_free (tmp2);
  
  memset (fd, 0, sizeof (fd));
  memset (readbuf2, 0, sizeof (readbuf2));
  memset (readbuf3, 0, sizeof (readbuf3));
  for (i = 0; i < 12; i++)
    {
      lsof_info[i] = readbuf2[i];
      tcp[i] = readbuf3[i];
      width[i] = 0;
    }

	g_spawn_async_with_pipes (NULL,filter_argv,NULL,0,NULL,NULL,NULL,NULL,&output,NULL,NULL);
		
	fp = fdopen (output, "r");
	
	g_strfreev (filter_argv);

	
  while (fgets (readbuf, BUFSIZ, fp))
    {
      repeat = FALSE;

      switch (readbuf[0])
	{

	case 'c':
	  {
	    mod = 0;
	    break;
	  }			/* COMMAND */
	case 'p':
	  {
	    mod = 1;
	    break;
	  }			/* PID */
	case 'g':
	  {
	    mod = 2;
	    break;
	  }			/* PGID */
	case 'R':
	  {
	    mod = 3;
	    break;
	  }			/* PPID */

	case 'u':
	  {
	    mod = 4;
	    break;
	  }			/* USER */
	case 'L':
	  {
	    mod = 4;
	    break;
	  }

	case 'f':
	  {
	    mod = 5;
	    strncat (&fd[0], &readbuf[1], strlen (readbuf) - 2);
	    break;
	  }			/* FD */
	case 'a':
	  {
	    mod = 5;
	    strncat (&fd[0], &readbuf[1], strlen (readbuf) - 2);
	    break;
	  }
	case 'l':
	  {
	    mod = 5;
	    strncat (&fd[0], &readbuf[1], strlen (readbuf) - 2);
	    break;
	  }

	case 't':
	  {
	    mod = 6;
	    break;
	  }			/* TYPE */

	case 'd':
	  {
	    mod = 7;
	    break;
	  }			/* DEVICE */
	case 'D':
	  {
	    mod = 7;
	    break;
	  }

	case 'o':
	  {
	    mod = 8;
	    break;
	  }			/* SIZE/OFF */
	case 's':
	  {
	    mod = 8;
	    break;
	  }

	case 'k':
	  {
	    mod = 9;
	    break;
	  }			/* NLINK */

	case 'i':
	  {
	    mod = 10;
	    break;
	  }			/* NODE */
	case 'P':
	  {
	    mod = 10;
	    break;
	  }

	case 'S':
	  {
	    mod = 11;
	    print = TRUE;
	    break;
	  }			/* NAME */
	case 'n':
	  {
	    mod = 11;
	    print = TRUE;
	    break;
	  }
	case 'T':
	  {
	    mod = 11;
	    repeat = TRUE;
	    break;
	  }

	default:
	  mod = 1000;
	}

      if (mod < 1000 && ((strlen (readbuf) - 2) > width[mod]))
	width[mod] = strlen (readbuf) - 2;

      if (repeat) /* if */
	{
	      strcat (tcp[11], "(");
	      strncat (tcp[11], &readbuf[1], strlen (readbuf) - 2);
		  strcat (tcp[11], ")");
		  
		  if (append_num == 1)
		  {
			  append_num++;
			  ADD_ROW
		  }

	  FILL_ROW
		  
	} /* _if */

      else /* else */
	{

	  if (mod < 1000 && mod != 5)
	    {
	      memset (readbuf2[mod], 0, sizeof (readbuf2[mod]));
	      strncpy (&readbuf2[mod][0], &readbuf[1], strlen (readbuf) - 2);
	      mod = 1000;
	    }

	  if (print)
	    {
	      strncpy (&readbuf2[5][0], &fd[0], strlen (fd));
	      memset (fd, 0, sizeof (fd));
			
		  if (strlen (tcp[0])>0)
		  {
			  gboolean add_line_table = TRUE;
			  
			  if (tmp_check_buts[16])
				  if ((!strcmp (tcp[0],"glsof")) || (!strcmp (tcp[0],"lsof")))
				  {
					  append_num--;
					  add_line_table = FALSE;
				  }
				  
			  if (add_line_table == TRUE)
				{
					ADD_ROW
					FILL_ROW
				}
		  }
		  
	      append_num++;
	      print = FALSE;
	      memset (readbuf3, 0, sizeof (readbuf3));
	      for (i = 0; i < 12; i++)
			strcpy (&readbuf3[i][0], &readbuf2[i][0]);
	      for (i = 5; i < 12; i++)
			memset (readbuf2[i], 0, sizeof (readbuf2[i]));
	    }

	  memset (readbuf, 0, sizeof (readbuf));
	} /* _else */
	
	} /* _while */
	
  if (strlen(readbuf) == 0)
	  if ((strcmp (tcp[0],"glsof")) && (strcmp (tcp[0],"lsof")))
		  {
			  ADD_ROW
			  FILL_ROW
		  }
		  
  fclose (fp);
	
	if ((gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM (save_at_refresh1))) && (!timeout_id))
    {
		if (first_save_at_refresh_call)
		{
			first_save_at_refresh_call=FALSE;
			on_save_as_clicked (NULL,GINT_TO_POINTER(3));
		}
		else 
			on_ok_button1_clicked (NULL,GINT_TO_POINTER(3));

	}
	else
		first_save_at_refresh_call=TRUE;
	
  /* close splash screen after 1 second */
	
  if (tmp_check_show_splash_conf == FALSE)
	  timeout_splash_window = gtk_timeout_add( 1000, close_splash_window, NULL );

}
