#include <gtk/gtk.h>
#include <string.h>

#include "interface.h"
#include "settings.h"
#include "xmlconfig.h"
#include "list_int_addr.h"
#include "international.h"


/* configuration */
extern gboolean tmp_check_buts_conf;
extern gboolean tmp_check_show_splash_conf;
extern gchar *tmp_entry_buts_conf;

/* interface */
extern gchar *path;
extern GtkWidget *window1;		/* main window */
extern GtkWidget *view;	/* element for main table */
extern GtkWidget *save_view_options_too1;

/* view_options */
extern gboolean state_fields[12];

/* list_int_addr */
extern GPtrArray *tmp_add_list;
extern GPtrArray *add_list_tmp;

/* main */
extern gchar *path_config;

/* extern */
GtkWidget *save_view_options;

/* Commands widgets && temp vars */
GtkWidget *sets_radio[6];
gboolean tmp_radio_buts[6] = { TRUE, TRUE, FALSE, FALSE, TRUE, FALSE };
GtkWidget *sets_check[17];

gboolean tmp_check_buts[17] =
  { FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE,
  FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE, FALSE
};

GtkWidget *sets_entry[7];
gchar *tmp_entry_buts[7] = { "", "", "", "", "", "", "" };

GtkWidget *spins_entry;
gfloat tmp_spin_buts = 0;
/* end extern */

static gboolean start = TRUE;
static gboolean ok_pressed2 = FALSE;

/* signals settings */

static void
on_settings_ok (GtkButton * button, gpointer user_data)
{

  int i;
	
  for (i = 0; i < 6; i++)
    tmp_radio_buts[i] =
      gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (sets_radio[i]));

  for (i = 0; i < 17; i++)
    tmp_check_buts[i] =
      gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (sets_check[i]));

  for (i = 0; i < 7; i++)
    tmp_entry_buts[i] =
      g_strdup (gtk_entry_get_text (GTK_ENTRY (sets_entry[i])));
  
  tmp_spin_buts = gtk_spin_button_get_value_as_int((GtkSpinButton *)spins_entry);
  
  /* free list addresses */
  
  if (tmp_add_list->len > 0)
	{
		free_useless_elements (tmp_add_list, add_list_tmp);
		g_ptr_array_free (tmp_add_list,FALSE);
		tmp_add_list = g_ptr_array_new ();
	}
	
  if (add_list_tmp->len > 0)
  {
	  for (i=0; i < add_list_tmp->len; i++)
		  g_ptr_array_add (tmp_add_list, g_ptr_array_index(add_list_tmp,i));
  }

  g_ptr_array_free (add_list_tmp,FALSE);
	
  /* close settings window */

  ok_pressed2 = TRUE;
  gtk_widget_destroy (GTK_WIDGET (user_data));
  on_refresh_clicked (NULL, NULL);

}

static void
on_settings_cancel (GtkButton * button, gpointer user_data)
{
	if (ok_pressed2 == FALSE)
	{
		if ( add_list_tmp->len > 0)
			free_useless_elements (add_list_tmp, tmp_add_list);
		
		g_ptr_array_free (add_list_tmp,FALSE);
		
		ok_pressed2 = TRUE;
		gtk_widget_destroy (GTK_WIDGET(user_data));
	}
	else
		ok_pressed2 = FALSE;
}

static gint 
escret_callback (GtkWidget *w, GdkEventKey *event, gpointer data)
{
	if (event->keyval==0xFF1B) /* ESC */
		on_settings_cancel (NULL, data);
		
	else if (event->keyval==0xFF0D) /* RETURN */
		on_settings_ok (NULL,data);
	
	return 0;
}

/* load and save settings */
int
load_sets (gchar * filename)
{

  int i,n;
  GtkWidget *dialog;
  unsigned int vopt[VIEWOPTIONS], depth, ret, act, sp[4];
  GtkTreeViewColumn *column;
  xmlChar *str;

  ret = checkConfig (path_config);
  if (ERRCONF == ret || -1 == ret)
    {
      puts ("ERROR");
      exit (1);
    }
printf ("questo valore %s\n",filename);
  ret = initWriteConfig (filename);
  if (-1 == ret)
    return -1;

  getViewOptions (vopt);

  for (i = 0; i < VIEWOPTIONS; i++)
    state_fields[i + 1] = vopt[i];

  /* page 0 - general */

    tmp_radio_buts[0] = !getIdorlogin ();
    tmp_radio_buts[2] = getIdorlogin ();
    
    tmp_radio_buts[1] = !getOffsetorsize ();
    tmp_radio_buts[3] = getOffsetorsize ();
    
    tmp_check_buts[0] = getAndsettings ();
  
    tmp_check_buts[16] = getHidefromoutput();

  /* page 1 - filesel */

    tmp_check_buts[1] = getProcessesexecuting (&str);
    tmp_entry_buts[0] = g_strdup (str);

    tmp_check_buts[2] = getIdprocesses (&str);
    tmp_entry_buts[1] = g_strdup (str);

    tmp_check_buts[3] = getPgidprocesses (&str);
    tmp_entry_buts[2] = g_strdup (str);

  /* page 2 - processes */

    tmp_check_buts[4] = getDisplaydirectory (&str, &depth);
    tmp_entry_buts[3] = g_strdup (str);
	
    tmp_check_buts[8] = depth;

    tmp_check_buts[5] = getFiledescriptors (&str, &act);
    tmp_entry_buts[4] = g_strdup (str);
	
    tmp_radio_buts[4] = !depth;
    tmp_radio_buts[5] = depth;

    tmp_check_buts[6] = getNameandid (&str);
    tmp_entry_buts[5] = g_strdup (str);

    tmp_check_buts[7] = getMaxlinks (&str);
    tmp_entry_buts[6] = g_strdup (str);

  /* page 3 - network */

    tmp_check_buts[9] = getInternetaddressesSelected();
    n = getInternetaddresses(tmp_add_list);
    //tmp_entry_buts[7] = g_strdup (str);

    tmp_check_buts[10] = getIpaddress ();

    tmp_check_buts[12] = getPortnumber ();

    tmp_check_buts[11] = getNfsfiles ();

    tmp_check_buts[13] = getUnixsocket ();
  
  /* page 4 - kernel */

    tmp_check_buts[14] = getTimeout (&str);
    tmp_spin_buts = g_strtod (g_strdup (str),NULL);

    tmp_check_buts[15] = getAvoiddangerous ();

  /* configuration */

  getLsofpath (&str);
  if (strlen (str))
    {
      tmp_entry_buts_conf = g_strdup (str);
      path = (char *) g_strconcat (str, " -F ", NULL);
    }
  
  tmp_check_buts_conf = getKeepsizeposition ();
  
  tmp_check_show_splash_conf = getSplashWindow();

  /* auto-execution */
	
  for (i = 1; i < 11; i++)
  {
	  column = gtk_tree_view_get_column (GTK_TREE_VIEW(view),i);
  	  gtk_tree_view_column_set_visible (column, state_fields[i]);
  }
  
  /* on_refresh_clicked (NULL, NULL); */

  getSizePosition (sp);
  gtk_window_move (GTK_WINDOW (window1), (gint) sp[X], (gint) sp[Y]);
  gtk_window_resize (GTK_WINDOW (window1), (gint) sp[WIDTH],
		     (gint) sp[HEIGHT]);

  /* close xml file */
  
  destroyReadConfig ();

  if (!start) {
  dialog = gtk_message_dialog_new (GTK_WINDOW (window1),
				   GTK_DIALOG_MODAL,
				   GTK_MESSAGE_INFO,
				   GTK_BUTTONS_OK, _("Settings loaded.") );
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
  gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);
  }
  else start = FALSE;
  return 0;
}

int
save_sets (gchar * filename)
{
  unsigned int ret, vopt[VIEWOPTIONS];
  int i;
  GtkWidget *dialog;
  gchar buffer[15];

  ret = checkConfig (path_config);
  if (ERRCONF == ret || -1 == ret)
    {
      puts ("ERROR");
      exit (1);
    }

  ret = initWriteConfig (path_config);
  if (-1 == ret)
    return -1;

  if (gtk_check_menu_item_get_active
      (GTK_CHECK_MENU_ITEM (save_view_options_too1)))
    {
      for (i = 0; i < VIEWOPTIONS; i++)
	vopt[i] = state_fields[i + 1];
      setViewOptions (vopt);
    }

  /* page 0 - general */
	
  setIdorlogin (tmp_radio_buts[2]);
  setOffsetorsize (tmp_radio_buts[3]);
  setAndsettings (tmp_check_buts[0]);
  setHidefromoutput(tmp_check_buts[16]);
	
  /* page 1 - filesel */
	
  setProcessesexecuting (tmp_check_buts[1], tmp_entry_buts[0]);
  setIdprocesses (tmp_check_buts[2], tmp_entry_buts[1]);
  setPgidprocesses (tmp_check_buts[3], tmp_entry_buts[2]);

  /* page 2 - processes */
	
  setDisplaydirectory (tmp_check_buts[4], tmp_entry_buts[3],
		       tmp_check_buts[8]);
  setFiledescriptors (tmp_check_buts[5], tmp_entry_buts[4],
		      tmp_radio_buts[5]);
  setNameandid (tmp_check_buts[6], tmp_entry_buts[5]);
  setMaxlinks (tmp_check_buts[7], tmp_entry_buts[6]);

  /* page 3 - network */
  
  //setInternetaddress (tmp_check_buts[9], tmp_entry_buts[7]);
  setInternetaddressesSelected(tmp_check_buts[9]);
  setInternetaddresses(tmp_add_list);
  setIpaddress (tmp_check_buts[10]);
  setPortnumber (tmp_check_buts[12]);
  setNfsfiles (tmp_check_buts[11]);
  setUnixsocket (tmp_check_buts[13]);

  /* page 4 - kernel */
  
  g_ascii_dtostr(buffer,15,tmp_spin_buts);
  setTimeout (tmp_check_buts[14], buffer);
  setAvoiddangerous (tmp_check_buts[15]);

  ret = destroyWriteConfig (filename, 0);
  if (-1 == ret) return -1;
	  
  /* dialog: settings saved */
  
  dialog = gtk_message_dialog_new (GTK_WINDOW (window1),
				   GTK_DIALOG_MODAL,
				   GTK_MESSAGE_INFO,
				   GTK_BUTTONS_OK, _("Settings saved.") );
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
  gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);
  return 0;
}

/* Settings Window */

/* draw big label */
static void
draw_big_label (gchar *label, GtkWidget *page)
{
  PangoAttrList     *attrs;
  PangoAttribute    *attr;
	
  GtkWidget *label1;
  GtkWidget *ebox;
  GtkWidget *frame;
  GtkWidget *hbox;
  
  ebox = gtk_event_box_new ();
  gtk_widget_set_state (ebox, GTK_STATE_PRELIGHT);
  gtk_box_pack_start (GTK_BOX (page), ebox, FALSE, TRUE, 0);
  gtk_widget_show (ebox);

  frame = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_OUT);
  gtk_container_add (GTK_CONTAINER (ebox), frame);
  gtk_widget_show (frame);

  hbox = gtk_hbox_new (FALSE, 4);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 4);
  gtk_container_add (GTK_CONTAINER (frame), hbox);
  gtk_widget_show (hbox);
	
  label1 = gtk_label_new (label);
  gtk_misc_set_alignment (GTK_MISC (label1), 0.0, 0.5);
  gtk_box_pack_start (GTK_BOX (hbox), label1, FALSE, FALSE, 0);
  gtk_widget_show (label1);

  attrs = pango_attr_list_new ();

  attr = pango_attr_scale_new (PANGO_SCALE_LARGE);
  attr->start_index = 0;
  attr->end_index   = -1;
  pango_attr_list_insert (attrs, attr);

  attr = pango_attr_weight_new (PANGO_WEIGHT_BOLD);
  attr->start_index = 0;
  attr->end_index   = -1;
  pango_attr_list_insert (attrs, attr);

  gtk_label_set_attributes (GTK_LABEL (label1), attrs);
  pango_attr_list_unref (attrs);
}

/* get row from menu */
static void
selection_changed_pref (GtkTreeSelection * selection, gpointer data)
{
	GtkTreeModel *model;
	GtkTreeIter iter;

	if (gtk_tree_selection_get_selected (selection, &model, &iter))
	{
		GtkTreePath *path;
		gint position;
		
		path = gtk_tree_model_get_path (model, &iter);
		position = gtk_tree_path_get_indices (path)[0];
		gtk_notebook_set_current_page (GTK_NOTEBOOK (data), position);
		gtk_tree_path_free (path);
	}
}				/* _selection_changed */


void
on_settings_clicked (GtkButton * button, gpointer user_data)
{
  GtkWidget *window2;
  GtkWidget *hbox1;
  GtkWidget *vbox_total;
  GtkWidget *notebook1;
  GtkWidget *table1;
  GtkWidget *empty_notebook_page;
  GtkWidget *hbuttonbox1;
  GtkWidget *button4;
  GtkWidget *button5;
  GtkWidget *button6;		/* set list */
	
  GtkObject *spinbutton1_adj;

  GSList *radiobutton3_group = NULL;
  GSList *radiobutton5_group = NULL;
  GSList *radiobutton7_group = NULL;

  GtkTooltips *button_bar_tips;

  GtkWidget *frame3;
  GtkWidget *hbox_page0;
  GtkWidget *frame4;
  GtkWidget *hbox2_page0;

  GtkWidget *hbox_page2;
  
  /* left column widgets */
  
  GtkWidget *view_settings_column;
  GtkCellRenderer   *cell;
  GtkWidget         *frame;
  GtkTreeSelection  *selection;
  GtkListStore	    *liststore;
  GtkTreeIter 	    iter;
  
  int index;


  button_bar_tips = gtk_tooltips_new ();

  window2 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window2), _("Settings"));
  gtk_window_set_position (GTK_WINDOW (window2), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (window2), FALSE, FALSE, TRUE);
  gtk_window_set_modal (GTK_WINDOW (window2), TRUE);

  vbox_total = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox_total);
  gtk_container_add (GTK_CONTAINER (window2), vbox_total);
  
  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox_total), hbox1, TRUE, TRUE, 0);
  
  /* left column */
  
  /* The categories tree */
  
  frame = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
  gtk_box_pack_start (GTK_BOX (hbox1), frame, FALSE, FALSE, 0);
  gtk_widget_show (frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 8);

  view_settings_column = gtk_tree_view_new ();
  selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (view_settings_column));

  gtk_tree_selection_set_mode (selection, GTK_SELECTION_SINGLE);
  liststore = gtk_list_store_new (1, G_TYPE_STRING);

  gtk_tree_view_set_model (GTK_TREE_VIEW (view_settings_column),
				 GTK_TREE_MODEL (liststore));
				 
  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (view_settings_column), FALSE);

  cell = gtk_cell_renderer_text_new ();
  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (view_settings_column), -1,
						     "ITEM", cell, "text", 0, NULL);

  gtk_widget_show (view_settings_column);
	
  gtk_container_add (GTK_CONTAINER (frame), view_settings_column);
	
  gtk_list_store_append (GTK_LIST_STORE (liststore), &iter); /* copy on list_store */
  gtk_list_store_set (liststore, &iter, 0, _("General  "), -1);
  
  gtk_list_store_append (GTK_LIST_STORE (liststore), &iter); /* copy on list_store */
  gtk_list_store_set (liststore, &iter, 0, _("Files  "), -1);
  
  gtk_list_store_append (GTK_LIST_STORE (liststore), &iter); /* copy on list_store */
  gtk_list_store_set (liststore, &iter, 0, _("Processes  "), -1);
  
  gtk_list_store_append (GTK_LIST_STORE (liststore), &iter); /* copy on list_store */
  gtk_list_store_set (liststore, &iter, 0, _("Network  "), -1);
  
  gtk_list_store_append (GTK_LIST_STORE (liststore), &iter); /* copy on list_store */
  gtk_list_store_set (liststore, &iter, 0, _("Kernel  "), -1);

/***************/

  frame = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
  gtk_box_pack_start (GTK_BOX (hbox1), frame, FALSE, FALSE, 0);
  gtk_widget_show (frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 8);
  
/* start notebook */

  notebook1 = gtk_notebook_new ();
  gtk_widget_show (notebook1);
  gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook1), FALSE);
  gtk_notebook_set_show_border (GTK_NOTEBOOK (notebook1), FALSE);
  gtk_container_add (GTK_CONTAINER (frame), notebook1);

/* page 0 */

  empty_notebook_page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (empty_notebook_page);
  gtk_container_add (GTK_CONTAINER (notebook1), empty_notebook_page);
  gtk_container_set_border_width (GTK_CONTAINER (empty_notebook_page), 0);
  
  /* set label */
  
  draw_big_label (_("General"),empty_notebook_page);
  
  /* _set label */
  
  table1 = gtk_table_new (4, 1, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (empty_notebook_page), table1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 8);
  
  frame3 = gtk_frame_new (_("ID or Login") );
  gtk_widget_show (frame3);
  gtk_table_attach (GTK_TABLE (table1), frame3, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  
  hbox_page0 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox_page0);
  gtk_container_add (GTK_CONTAINER (frame3), hbox_page0);

  sets_radio[0] =
    gtk_radio_button_new_with_mnemonic (NULL, _("ID number"));
  gtk_widget_show (sets_radio[0]);
  gtk_box_pack_start (GTK_BOX (hbox_page0), sets_radio[0], FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (sets_radio[0]),
			      radiobutton7_group);
  radiobutton7_group =
    gtk_radio_button_group (GTK_RADIO_BUTTON (sets_radio[0]));
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), sets_radio[0],
			_("(-l) For example display '501' and not user name 'gnele'."),
			NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_radio[0]),
				tmp_radio_buts[0]);

  sets_radio[2] =
    gtk_radio_button_new_with_mnemonic (NULL, _("Login name"));
  gtk_widget_show (sets_radio[2]);
  gtk_box_pack_start (GTK_BOX (hbox_page0), sets_radio[2], FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (sets_radio[2]),
			      radiobutton7_group);
  radiobutton7_group =
    gtk_radio_button_group (GTK_RADIO_BUTTON (sets_radio[2]));
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), sets_radio[2],
			_("For example display 'gnele' and not user ID '501'."),
			NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_radio[2]),
				tmp_radio_buts[2]);
				
  frame4 = gtk_frame_new ( _("Offset or Size") );
  gtk_widget_show (frame4);
  gtk_table_attach (GTK_TABLE (table1), frame4, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  
  hbox2_page0 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2_page0);
  gtk_container_add (GTK_CONTAINER (frame4), hbox2_page0);
  
  sets_radio[1] =
    gtk_radio_button_new_with_mnemonic (NULL, _("File offset"));
  gtk_widget_show (sets_radio[1]);
  gtk_box_pack_start (GTK_BOX (hbox2_page0), sets_radio[1], FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (sets_radio[1]),
			      radiobutton3_group);
  radiobutton3_group =
    gtk_radio_button_group (GTK_RADIO_BUTTON (sets_radio[1]));
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_radio[1]),
				tmp_radio_buts[1]);

  sets_radio[3] =
    gtk_radio_button_new_with_mnemonic (NULL, _("File size "));
  gtk_widget_show (sets_radio[3]);
  gtk_box_pack_start (GTK_BOX (hbox2_page0), sets_radio[3], FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (sets_radio[3]),
			      radiobutton3_group);
  radiobutton3_group =
    gtk_radio_button_group (GTK_RADIO_BUTTON (sets_radio[3]));
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_radio[3]),
				tmp_radio_buts[3]);

  sets_check[0] =
    gtk_check_button_new_with_mnemonic (_("AND all settings"));
  gtk_widget_show (sets_check[0]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[0], 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[0]),
				tmp_check_buts[0]);

  sets_check[16] =
    gtk_check_button_new_with_mnemonic (_("Avoid Output Of \"GLsof\" and \"Lsof\" "));
  gtk_widget_show (sets_check[16]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[16], 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[16]),
				tmp_check_buts[16]);


/* page 1 */

  empty_notebook_page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (empty_notebook_page);
  gtk_container_add (GTK_CONTAINER (notebook1), empty_notebook_page);
  gtk_container_set_border_width (GTK_CONTAINER (empty_notebook_page), 0);

  /* set label */

  draw_big_label (_("Files"),empty_notebook_page);
  
  /* _set label */
  
  table1 = gtk_table_new (3, 2, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (empty_notebook_page), table1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 8);

  sets_check[1] =
    gtk_check_button_new_with_mnemonic (_("List of files for processes executing "));
  gtk_widget_show (sets_check[1]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[1], 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), sets_check[1],
			_("(-c) Use comma-separated (no spaces). For example 'awk,perl,gimp,..'."),
			NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[1]),
				tmp_check_buts[1]);

  sets_check[2] =
    gtk_check_button_new_with_mnemonic (_("List of files for ID processes "));
  gtk_widget_show (sets_check[2]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[2], 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), sets_check[2],
			_("(-p) Use comma-separated (no spaces). For example '123,456,..'."),
			NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[2]),
				tmp_check_buts[2]);

  sets_check[3] =
    gtk_check_button_new_with_mnemonic (_("List of files for PGID processes "));
  gtk_widget_show (sets_check[3]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[3], 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), sets_check[3],
			_("(-g) Use comma-separated (no spaces). For example '123,456,...'."),
			NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[3]),
				tmp_check_buts[3]);

  sets_entry[0] = gtk_entry_new ();
  gtk_widget_show (sets_entry[0]);
  gtk_table_attach (GTK_TABLE (table1), sets_entry[0], 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_entry_set_text (GTK_ENTRY (sets_entry[0]), tmp_entry_buts[0]);

  sets_entry[1] = gtk_entry_new ();
  gtk_widget_show (sets_entry[1]);
  gtk_table_attach (GTK_TABLE (table1), sets_entry[1], 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_entry_set_text (GTK_ENTRY (sets_entry[1]), tmp_entry_buts[1]);

  sets_entry[2] = gtk_entry_new ();
  gtk_widget_show (sets_entry[2]);
  gtk_table_attach (GTK_TABLE (table1), sets_entry[2], 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_entry_set_text (GTK_ENTRY (sets_entry[2]), tmp_entry_buts[2]);

/* page 2 */

  empty_notebook_page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (empty_notebook_page);
  gtk_container_add (GTK_CONTAINER (notebook1), empty_notebook_page);
  gtk_container_set_border_width (GTK_CONTAINER (empty_notebook_page), 0);

  /* set label */

  draw_big_label (_("Processes"),empty_notebook_page);
  
  /* _set label */
  
  /* set table */
  
  table1 = gtk_table_new (4, 3, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (empty_notebook_page), table1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 8);
  
  /* _set table */

  sets_check[4] =
    gtk_check_button_new_with_mnemonic (_("Display Directory "));
  gtk_widget_show (sets_check[4]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[4], 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), sets_check[4],
			_("(+d) NOT descend the directory tree . 'Complete depth' (+D) descend the directory tree."),
			NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[4]),
				tmp_check_buts[4]);

  sets_check[5] =
    gtk_check_button_new_with_mnemonic (_("List  of  files  descriptors "));
  gtk_widget_show (sets_check[5]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[5], 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), sets_check[5],
			_("(-d) Use comma-separated (no spaces). For example 'txt,1,3,...'."),
			NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[5]),
				tmp_check_buts[5]);

  sets_check[6] =
    gtk_check_button_new_with_mnemonic (_("List of files for user login name or ID "));
  gtk_widget_show (sets_check[6]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[6], 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), sets_check[6],
			_("(-u) Use comma-separated (no spaces). For example 'root,548,gnele,...'."),
			NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[6]),
				tmp_check_buts[6]);

  sets_check[7] =
    gtk_check_button_new_with_mnemonic (_("Max number of links for a file "));
  gtk_widget_show (sets_check[7]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[7], 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[7]),
				tmp_check_buts[7]);

  sets_entry[3] = gtk_entry_new ();
  gtk_widget_show (sets_entry[3]);
  gtk_table_attach (GTK_TABLE (table1), sets_entry[3], 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_entry_set_text (GTK_ENTRY (sets_entry[3]), tmp_entry_buts[3]);

  sets_check[8] = gtk_check_button_new_with_mnemonic (_("Complete depth "));
  gtk_widget_show (sets_check[8]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[8], 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[8]),
				tmp_check_buts[8]);

  sets_entry[4] = gtk_entry_new ();
  gtk_widget_show (sets_entry[4]);
  gtk_table_attach (GTK_TABLE (table1), sets_entry[4], 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_entry_set_text (GTK_ENTRY (sets_entry[4]), tmp_entry_buts[4]);
  
  hbox_page2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox_page2);
  gtk_table_attach (GTK_TABLE (table1), hbox_page2, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  
  sets_radio[4] = gtk_radio_button_new_with_mnemonic (NULL, _("include "));
  gtk_widget_show (sets_radio[4]);
  gtk_box_pack_start (GTK_BOX (hbox_page2), sets_radio[4], FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (sets_radio[4]),
			      radiobutton5_group);
  radiobutton5_group =
    gtk_radio_button_group (GTK_RADIO_BUTTON (sets_radio[4]));

  sets_radio[5] = gtk_radio_button_new_with_mnemonic (NULL, _("exclude "));
  gtk_widget_show (sets_radio[5]);
  gtk_box_pack_start (GTK_BOX (hbox_page2), sets_radio[5], FALSE, FALSE, 0);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (sets_radio[5]),
			      radiobutton5_group);
  radiobutton5_group =
    gtk_radio_button_group (GTK_RADIO_BUTTON (sets_radio[5]));
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_radio[5]),
				tmp_radio_buts[5]);

  sets_entry[5] = gtk_entry_new ();
  gtk_widget_show (sets_entry[5]);
  gtk_table_attach (GTK_TABLE (table1), sets_entry[5], 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_entry_set_text (GTK_ENTRY (sets_entry[5]), tmp_entry_buts[5]);

  sets_entry[6] = gtk_entry_new ();
  gtk_widget_show (sets_entry[6]);
  gtk_table_attach (GTK_TABLE (table1), sets_entry[6], 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_entry_set_text (GTK_ENTRY (sets_entry[6]), tmp_entry_buts[6]);


/* page 3 */

  empty_notebook_page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (empty_notebook_page);
  gtk_container_add (GTK_CONTAINER (notebook1), empty_notebook_page);
  gtk_container_set_border_width (GTK_CONTAINER (empty_notebook_page), 0);

  /* set label */

  draw_big_label (_("Network"),empty_notebook_page);
  
  /* _set label */
  
  table1 = gtk_table_new (5, 2, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (empty_notebook_page), table1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 8);

  /* network (-i) */
  
  sets_check[9] =
    gtk_check_button_new_with_mnemonic (_("List of Files for Internet Address (all items are optional)"));
  gtk_widget_show (sets_check[9]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[9], 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), sets_check[9],
			_("(-i) [46][protocol][@hostname|hostaddr][:service|port]"),
			NULL);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[9]),
				tmp_check_buts[9]);
				
  button6 = gtk_button_new_with_label (_("Set List..."));
  gtk_widget_show (button6);
  gtk_table_attach (GTK_TABLE (table1), button6, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  GTK_WIDGET_SET_FLAGS (button6, GTK_CAN_DEFAULT);
  
  /* end (-i) */

  sets_check[10] =
    gtk_check_button_new_with_mnemonic (_("Display IP addresses "));
  gtk_widget_show (sets_check[10]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[10], 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[10]),
				tmp_check_buts[10]);

  sets_check[11] =
    gtk_check_button_new_with_mnemonic (_("List of NFS files "));
  gtk_widget_show (sets_check[11]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[11], 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[11]),
				tmp_check_buts[11]);
  

  sets_check[12] =
    gtk_check_button_new_with_mnemonic (_("Display port numbers "));
  gtk_widget_show (sets_check[12]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[12], 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[12]),
				tmp_check_buts[12]);

  sets_check[13] =
    gtk_check_button_new_with_mnemonic (_("List of Unix domain socket files "));
  gtk_widget_show (sets_check[13]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[13], 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[13]),
				tmp_check_buts[13]);

/* page 4 */

  empty_notebook_page = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (empty_notebook_page);
  gtk_container_add (GTK_CONTAINER (notebook1), empty_notebook_page);
  gtk_container_set_border_width (GTK_CONTAINER (empty_notebook_page), 0);

  /* set label */

  draw_big_label (_("Kernel"),empty_notebook_page);
  
  /* _set label */
  
  table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (empty_notebook_page), table1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 8);

  sets_check[14] =
    gtk_check_button_new_with_mnemonic (_("Time-out seconds for dangerous Kernel functions "));
  gtk_widget_show (sets_check[14]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[14], 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[14]),
				tmp_check_buts[14]);

  sets_check[15] =
    gtk_check_button_new_with_mnemonic (_("Avoid dangerous Kernel functions that might block lsof "));
  gtk_widget_show (sets_check[15]);
  gtk_table_attach (GTK_TABLE (table1), sets_check[15], 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sets_check[15]),
				tmp_check_buts[15]);
  
  spinbutton1_adj = gtk_adjustment_new (tmp_spin_buts, 1, 3.16224e+07, 1, 10, 10);
  spins_entry = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 0);
  gtk_table_attach (GTK_TABLE (table1), spins_entry, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL | GTK_EXPAND),
                    (GtkAttachOptions) (0), 2, 2);
  gtk_widget_show (spins_entry);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spins_entry), TRUE);

/* end pages */

/* ok-cancel buttons */

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_container_add (GTK_CONTAINER (vbox_total), hbuttonbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox1), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_END);
  gtk_box_set_spacing (GTK_BOX (hbuttonbox1), 10);

  button5 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (button5);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button5);
  GTK_WIDGET_SET_FLAGS (button5, GTK_CAN_DEFAULT);

  button4 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button4);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button4);
  GTK_WIDGET_SET_FLAGS (button4, GTK_CAN_DEFAULT);
  
  gtk_widget_show (window2);
  gdk_window_raise (window2->window);
  
  /* copy tmp_add_list -> add_list / control list addresses */
  
  add_list_tmp = g_ptr_array_new ();
  
  for (index=0; index < tmp_add_list->len; index++)
	  g_ptr_array_add (add_list_tmp, g_ptr_array_index(tmp_add_list,index));
  
  /* signals */

  g_signal_connect (G_OBJECT (window2), "destroy",
		      G_CALLBACK (on_settings_cancel), (gpointer) window2);

  g_signal_connect (G_OBJECT (button4), "clicked",
		      G_CALLBACK (on_settings_cancel), (gpointer) window2);

  g_signal_connect (G_OBJECT (button5), "clicked",
		      G_CALLBACK (on_settings_ok), (gpointer) window2);
			  
  g_signal_connect (G_OBJECT (button6), "clicked",
		      G_CALLBACK (on_set_list_clicked), NULL);
			  
  g_signal_connect (G_OBJECT (window2), "key_press_event",
              G_CALLBACK (escret_callback), (gpointer) window2);
  
  g_signal_connect (G_OBJECT (selection), "changed", 
  			  G_CALLBACK (selection_changed_pref), (gpointer) notebook1);

}
