#include <gtk/gtk.h>

#include "international.h"


/* interface */
extern GtkWidget *view;	/* element for main table */

static GtkWidget *checkbutton_fields[10];

gboolean state_fields[] =
  { TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE };


/* view options signals */

static void
ok_exit (GtkButton * button, gpointer user_data)
{
  int i;
  GtkTreeViewColumn *column;

  for (i = 1; i < 11; i++)
    {
	  state_fields[i] = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_fields[i - 1]));
	  column = gtk_tree_view_get_column (GTK_TREE_VIEW(view),i);
  	  gtk_tree_view_column_set_visible (column, state_fields[i]);
    }
	
  gtk_widget_destroy (GTK_WIDGET (user_data));
}

static void 
viewopt_callback (GtkWidget *w, GdkEventKey *event, gpointer data)
{
	if (event->keyval==0xFF1B) /* ESC */
		gtk_widget_destroy (w);
	else if (event->keyval==0xFF0D) /* RETURN */
		ok_exit (GTK_BUTTON (w), data);
}

/* View Options Window */

void
on_preferences_clicked (GtkButton * button, gpointer user_data)
{

  GtkWidget *window3;
  GtkWidget *vbox4;
  GtkWidget *hbox6;
  GtkWidget *frame3;
  GtkWidget *vbox5;
  GtkWidget *label3;
  GtkWidget *frame4;
  GtkWidget *vbox6;
  GtkWidget *label4;
  GtkWidget *hbuttonbox4;
  GtkWidget *button21;
  GtkWidget *button22;


  window3 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window3), _("View Options"));
  gtk_window_set_position (GTK_WINDOW (window3), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (window3), TRUE);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (window3), vbox4);

  hbox6 = gtk_hbox_new (TRUE, 0);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox6, TRUE, TRUE, 0);

  frame3 = gtk_frame_new (NULL);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (hbox6), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 5);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (frame3), vbox5);

  /* process information list */
	
  checkbutton_fields[0] = gtk_check_button_new_with_mnemonic (_("PID - process ID"));
  gtk_widget_show (checkbutton_fields[0]);
  gtk_box_pack_start (GTK_BOX (vbox5), checkbutton_fields[0], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[0]),state_fields[1]);
	
  checkbutton_fields[1] = gtk_check_button_new_with_mnemonic (_("PGID - process group ID"));
  gtk_widget_show (checkbutton_fields[1]);
  gtk_box_pack_start (GTK_BOX (vbox5), checkbutton_fields[1], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[1]),state_fields[2]);
	
  checkbutton_fields[2] = gtk_check_button_new_with_mnemonic (_("PPID - parent process ID"));
  gtk_widget_show (checkbutton_fields[2]);
  gtk_box_pack_start (GTK_BOX (vbox5), checkbutton_fields[2], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[2]),state_fields[3]);
	
  checkbutton_fields[3] = gtk_check_button_new_with_mnemonic (_("USER - process user ID"));
  gtk_widget_show (checkbutton_fields[3]);
  gtk_box_pack_start (GTK_BOX (vbox5), checkbutton_fields[3], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[3]),state_fields[4]);

  /* _process information list */

  label3 = gtk_label_new (_("Process Information"));
  gtk_widget_show (label3);
  gtk_frame_set_label_widget (GTK_FRAME (frame3), label3);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);

  frame4 = gtk_frame_new (NULL);
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (hbox6), frame4, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 5);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (frame4), vbox6);
  
  /* file information list */
	
  checkbutton_fields[4] = gtk_check_button_new_with_mnemonic (_("FD - file descriptor"));
  gtk_widget_show (checkbutton_fields[4]);
  gtk_box_pack_start (GTK_BOX (vbox6), checkbutton_fields[4], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[4]), state_fields[5]);

  checkbutton_fields[5] = gtk_check_button_new_with_mnemonic (_("TYPE - file's type"));
  gtk_widget_show (checkbutton_fields[5]);
  gtk_box_pack_start (GTK_BOX (vbox6), checkbutton_fields[5], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[5]), state_fields[6]);

  checkbutton_fields[6] = gtk_check_button_new_with_mnemonic (_("DEVICE - file's major/minor device number"));
  gtk_widget_show (checkbutton_fields[6]);
  gtk_box_pack_start (GTK_BOX (vbox6), checkbutton_fields[6], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[6]), state_fields[7]);

  checkbutton_fields[7] = gtk_check_button_new_with_mnemonic (_("SIZE/OFF - file's size/offset"));
  gtk_widget_show (checkbutton_fields[7]);
  gtk_box_pack_start (GTK_BOX (vbox6), checkbutton_fields[7], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[7]), state_fields[8]);

  checkbutton_fields[8] = gtk_check_button_new_with_mnemonic (_("NLINK - number of links for a file"));
  gtk_widget_show (checkbutton_fields[8]);
  gtk_box_pack_start (GTK_BOX (vbox6), checkbutton_fields[8], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[8]), state_fields[9]);

  checkbutton_fields[9] = gtk_check_button_new_with_mnemonic (_("NODE - file's inode number"));
  gtk_widget_show (checkbutton_fields[9]);
  gtk_box_pack_start (GTK_BOX (vbox6), checkbutton_fields[9], FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(checkbutton_fields[9]), state_fields[10]);
	
  /* _file information list */


  label4 = gtk_label_new (_("File Information"));
  gtk_widget_show (label4);
  gtk_frame_set_label_widget (GTK_FRAME (frame4), label4);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);

  hbuttonbox4 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox4);
  gtk_box_pack_start (GTK_BOX (vbox4), hbuttonbox4, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox4), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox4), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox4), 10);

  button21 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (button21);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), button21);
  GTK_WIDGET_SET_FLAGS (button21, GTK_CAN_DEFAULT);

  button22 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button22);
  gtk_container_add (GTK_CONTAINER (hbuttonbox4), button22);
  GTK_WIDGET_SET_FLAGS (button22, GTK_CAN_DEFAULT);
  
  gtk_widget_show (window3);
  gdk_window_raise (window3->window);
  
  /* signals */

  g_signal_connect (G_OBJECT (button21), "clicked",
		      G_CALLBACK (ok_exit), (gpointer) window3);

  g_signal_connect_swapped (G_OBJECT (button22), "clicked",
		      G_CALLBACK (gtk_object_destroy), (gpointer) window3);

  g_signal_connect (G_OBJECT (window3), "destroy",
		      G_CALLBACK (gtk_object_destroy), NULL);
			 
  g_signal_connect (G_OBJECT (window3), "key_press_event",
              G_CALLBACK (viewopt_callback), NULL);

  gtk_widget_grab_focus (window3);
}
