#include <libxml/parser.h>
#include <libxml/xpath.h>

#define DTD PACKAGE_DATA_DIR"/glsof/xml_data_type_doc/config.dtd"

#define ERRCONF 255

#define VIEWOPTIONS 10

#define PID 0
#define PGID 1
#define PPID 2
#define USER 3
#define FD 4
#define TYPE 5
#define DEVICE 6
#define SIZEOFFSET 7
#define NLINK 8
#define NODE 9

#define X 0
#define Y 1
#define WIDTH 2
#define HEIGHT 3


/* init and destroy functions */
int initReadConfig(char *);
void destroyReadConfig();

int initWriteConfig(char *);
int destroyWriteConfig(char *, unsigned int);

/* get functions */
/* view options */
void getViewOptions(unsigned int []);
/* settings */
/* general*/
unsigned int getAndsettings();
unsigned int getIdorlogin();
unsigned int getOffsetorsize();
unsigned int getHidefromoutput();
/* files */
unsigned int getProcessesexecuting(xmlChar **);
unsigned int getIdprocesses(xmlChar **);
unsigned int getPgidprocesses(xmlChar **);
/* processes */
unsigned int getDisplaydirectory(xmlChar **, unsigned int *);
unsigned int getFiledescriptors(xmlChar **, unsigned int *);
unsigned int getNameandid(xmlChar **);
unsigned int getMaxlinks(xmlChar **);
/* network */
unsigned int getInternetaddressesSelected();
unsigned int getInternetaddresses(GPtrArray *);
unsigned int getIpaddress();
unsigned int getPortnumber();
unsigned int getNfsfiles();
unsigned int getUnixsocket();
/* kernel */
unsigned int getTimeout(xmlChar **);
unsigned int getAvoiddangerous();


/* set functions */
/* view options */
void setViewOptions(unsigned int []);
/* settings */
/* general*/
void setAndsettings(unsigned int);
void setIdorlogin(unsigned int);
void setOffsetorsize(unsigned int);
void setHidefromoutput(unsigned int);
/* files */
void setProcessesexecuting(unsigned int, xmlChar *);
void setIdprocesses(unsigned int, xmlChar *);
void setPgidprocesses(unsigned int, xmlChar *);
/* processes */
void setDisplaydirectory(unsigned int, xmlChar *, unsigned int);
void setFiledescriptors(unsigned int, xmlChar *, unsigned int);
void setNameandid(unsigned int, xmlChar *);
void setMaxlinks(unsigned int, xmlChar *);
/* network */
void setInternetaddressesSelected(unsigned int);
void setInternetaddresses(GPtrArray *tmp_list);
void setIpaddress(unsigned int);
void setPortnumber(unsigned int);
void setNfsfiles(unsigned int);
void setUnixsocket(unsigned int);
/* kernel */
void setTimeout(unsigned int, xmlChar *);
void setAvoiddangerous(unsigned int);



/* gtklsof config */
void getLsofpath(xmlChar **);
void setLsofpath(xmlChar *);

void getSizePosition(unsigned int []);
void setSizePosition(unsigned int []);

unsigned int getKeepsizeposition();
void setKeepsizeposition(unsigned int);

unsigned int getSplashWindow();
void setSplashWindow(unsigned int);

/* utility functions */
unsigned int getNodeIntVal(xmlChar *);
xmlChar *getNodeStringVal(xmlChar *);
xmlNodeSetPtr getNodes(xmlChar *);
void setNodeContent(xmlChar *, xmlChar *);

unsigned int checkConfig(char *);

void cleanup();
